Index: /trunk/src/bp-groups/bp-groups-classes.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-classes.php	(revision 9470)
+++ /trunk/src/bp-groups/bp-groups-classes.php	(revision 9471)
@@ -260,5 +260,7 @@
 	 */
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->creator_id   = apply_filters( 'groups_group_creator_id_before_save',   $this->creator_id,   $this->id );
@@ -356,5 +358,5 @@
 	 */
 	public function delete() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// Delete groupmeta for the group
@@ -374,4 +376,6 @@
 
 		wp_cache_delete( $this->id, 'bp_groups' );
+
+		$bp = buddypress();
 
 		// Finally remove the group entry from the DB
@@ -393,8 +397,8 @@
 	 */
 	public static function group_exists( $slug, $table_name = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $table_name ) )
-			$table_name = $bp->groups->table_name;
+			$table_name = buddypress()->groups->table_name;
 
 		if ( empty( $slug ) )
@@ -425,5 +429,8 @@
 	 */
 	public static function get_invites( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		return $wpdb->get_col( $wpdb->prepare( "SELECT user_id FROM {$bp->groups->table_name_members} WHERE group_id = %d and is_confirmed = 0 AND inviter_id = %d", $group_id, $user_id ) );
 	}
@@ -447,5 +454,5 @@
 	 */
 	public static function filter_user_groups( $filter, $user_id = 0, $order = false, $limit = null, $page = null ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
@@ -464,4 +471,6 @@
 		if ( empty( $gids['groups'] ) )
 			return false;
+
+		$bp = buddypress();
 
 		$gids = esc_sql( implode( ',', wp_parse_id_list( $gids['groups'] ) ) );
@@ -491,5 +500,5 @@
 	 */
 	public static function search_groups( $filter, $limit = null, $page = null, $sort_by = false, $order = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$search_terms_like = '%' . bp_esc_like( $filter ) . '%';
@@ -509,4 +518,6 @@
 			$hidden_sql = "AND status != 'hidden'";
 
+		$bp = buddypress();
+
 		$paged_groups = $wpdb->get_results( $wpdb->prepare( "SELECT id as group_id FROM {$bp->groups->table_name} WHERE ( name LIKE %s OR description LIKE %s ) {$hidden_sql} {$order_sql} {$pag_sql}", $search_terms_like, $search_terms_like ) );
 		$total_groups = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(id) FROM {$bp->groups->table_name} WHERE ( name LIKE %s OR description LIKE %s ) {$hidden_sql}", $search_terms_like, $search_terms_like ) );
@@ -522,5 +533,7 @@
 	 */
 	public static function check_slug( $slug ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT slug FROM {$bp->groups->table_name} WHERE slug = %s", $slug ) );
@@ -534,5 +547,7 @@
 	 */
 	public static function get_slug( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT slug FROM {$bp->groups->table_name} WHERE id = %d", $group_id ) );
@@ -546,5 +561,7 @@
 	 */
 	public static function has_members( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$members = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(id) FROM {$bp->groups->table_name_members} WHERE group_id = %d", $group_id ) );
@@ -564,5 +581,7 @@
 	 */
 	public static function has_membership_requests( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(id) FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 0", $group_id ) );
@@ -584,9 +603,11 @@
 	 */
 	public static function get_membership_requests( $group_id, $limit = null, $page = null ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( !empty( $limit ) && !empty( $page ) ) {
 			$pag_sql = $wpdb->prepare( " LIMIT %d, %d", intval( ( $page - 1 ) * $limit), intval( $limit ) );
 		}
+
+		$bp = buddypress();
 
 		$paged_requests = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 0 AND inviter_id = 0{$pag_sql}", $group_id ) );
@@ -648,5 +669,5 @@
 	 */
 	public static function get( $args = array() ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// Backward compatibility with old method of passing arguments
@@ -687,4 +708,6 @@
 
 		$r = wp_parse_args( $args, $defaults );
+
+		$bp = buddypress();
 
 		$sql       = array();
@@ -1013,5 +1036,5 @@
 	 */
 	public static function get_by_most_forum_topics( $limit = null, $page = null, $user_id = 0, $search_terms = false, $populate_extras = true, $exclude = false ) {
-		global $wpdb, $bp, $bbdb;
+		global $wpdb, $bbdb;
 
 		if ( empty( $bbdb ) )
@@ -1034,4 +1057,6 @@
 			$exclude_sql = " AND g.id NOT IN ({$exclude})";
 		}
+
+		$bp = buddypress();
 
 		if ( !empty( $user_id ) ) {
@@ -1077,5 +1102,5 @@
 	 */
 	public static function get_by_most_forum_posts( $limit = null, $page = null, $search_terms = false, $populate_extras = true, $exclude = false ) {
-		global $wpdb, $bp, $bbdb;
+		global $wpdb, $bbdb;
 
 		if ( empty( $bbdb ) )
@@ -1098,4 +1123,6 @@
 			$exclude_sql = " AND g.id NOT IN ({$exclude})";
 		}
+
+		$bp = buddypress();
 
 		if ( !empty( $user_id ) ) {
@@ -1138,5 +1165,5 @@
 	 */
 	public static function get_by_letter( $letter, $limit = null, $page = null, $populate_extras = true, $exclude = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$pag_sql = $hidden_sql = $exclude_sql = '';
@@ -1152,4 +1179,6 @@
 			}
 		}
+
+		$bp = buddypress();
 
 		if ( !empty( $exclude ) ) {
@@ -1206,5 +1235,5 @@
 	 */
 	public static function get_random( $limit = null, $page = null, $user_id = 0, $search_terms = false, $populate_extras = true, $exclude = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$pag_sql = $hidden_sql = $search_sql = $exclude_sql = '';
@@ -1226,4 +1255,6 @@
 			$exclude_sql = " AND g.id NOT IN ({$exclude})";
 		}
+
+		$bp = buddypress();
 
 		if ( !empty( $user_id ) ) {
@@ -1264,8 +1295,10 @@
 	 */
 	public static function get_group_extras( &$paged_groups, &$group_ids, $type = false ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		if ( empty( $group_ids ) )
 			return $paged_groups;
+
+		$bp = buddypress();
 
 		// Sanitize group IDs
@@ -1338,5 +1371,7 @@
 	 */
 	public static function delete_all_invites( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE group_id = %d AND invite_sent = 1", $group_id ) );
@@ -1352,5 +1387,5 @@
 	 */
 	public static function get_total_group_count() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$hidden_sql = '';
@@ -1358,4 +1393,6 @@
 			$hidden_sql = "WHERE status != 'hidden'";
 
+		$bp = buddypress();
+
 		return $wpdb->get_var( "SELECT COUNT(id) FROM {$bp->groups->table_name} {$hidden_sql}" );
 	}
@@ -1369,5 +1406,7 @@
 	 */
 	public static function get_global_forum_topic_count( $type ) {
-		global $bbdb, $wpdb, $bp;
+		global $bbdb, $wpdb;
+
+		$bp = buddypress();
 
 		if ( 'unreplied' == $type )
@@ -1391,5 +1430,7 @@
 	 */
 	public static function get_total_member_count( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(id) FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 1 AND is_banned = 0", $group_id ) );
@@ -1406,5 +1447,5 @@
 	 */
 	public static function get_global_topic_count( $status = 'public', $search_terms = false ) {
-		global $bbdb, $wpdb, $bp;
+		global $bbdb, $wpdb;
 
 		switch ( $status ) {
@@ -1427,4 +1468,6 @@
 		}
 
+		$bp = buddypress();
+
 		$sql = array();
 
@@ -1452,6 +1495,7 @@
 	 */
 	public static function get_group_type_ids() {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp  = buddypress();
 		$ids = array();
 
@@ -1981,5 +2025,7 @@
 	 */
 	public function populate() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		if ( $this->user_id && $this->group_id && !$this->id )
@@ -2015,5 +2061,7 @@
 	 */
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->user_id       = apply_filters( 'groups_member_user_id_before_save',       $this->user_id,       $this->id );
@@ -2145,6 +2193,7 @@
 	 */
 	public function remove() {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d", $this->user_id, $this->group_id );
 
@@ -2195,6 +2244,7 @@
 	 */
 	public static function delete( $user_id, $group_id ) {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp = buddypress();
 		$remove = $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d", $user_id, $group_id ) );
 
@@ -2222,9 +2272,11 @@
 	 */
 	public static function get_group_ids( $user_id, $limit = false, $page = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$pag_sql = '';
 		if ( !empty( $limit ) && !empty( $page ) )
 			$pag_sql = $wpdb->prepare( " LIMIT %d, %d", intval( ( $page - 1 ) * $limit), intval( $limit ) );
+
+		$bp = buddypress();
 
 		// If the user is logged in and viewing their own groups, we can show hidden and private groups
@@ -2258,5 +2310,5 @@
 	 */
 	public static function get_recently_joined( $user_id, $limit = false, $page = false, $filter = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$user_id_sql = $pag_sql = $hidden_sql = $filter_sql = '';
@@ -2274,4 +2326,6 @@
 		if ( $user_id != bp_loggedin_user_id() )
 			$hidden_sql = " AND g.status != 'hidden'";
+
+		$bp = buddypress();
 
 		$paged_groups = $wpdb->get_results( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count'{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 ORDER BY m.date_modified DESC {$pag_sql}" );
@@ -2297,5 +2351,5 @@
 	 */
 	public static function get_is_admin_of( $user_id, $limit = false, $page = false, $filter = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$user_id_sql = $pag_sql = $hidden_sql = $filter_sql = '';
@@ -2313,4 +2367,6 @@
 		if ( $user_id != bp_loggedin_user_id() )
 			$hidden_sql = " AND g.status != 'hidden'";
+
+		$bp = buddypress();
 
 		$paged_groups = $wpdb->get_results( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count'{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_admin = 1 ORDER BY m.date_modified ASC {$pag_sql}" );
@@ -2336,5 +2392,5 @@
 	 */
 	public static function get_is_mod_of( $user_id, $limit = false, $page = false, $filter = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$user_id_sql = $pag_sql = $hidden_sql = $filter_sql = '';
@@ -2353,4 +2409,6 @@
 			$hidden_sql = " AND g.status != 'hidden'";
 
+		$bp = buddypress();
+
 		$paged_groups = $wpdb->get_results( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count'{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY m.date_modified ASC {$pag_sql}" );
 		$total_groups = $wpdb->get_var( "SELECT COUNT(DISTINCT m.group_id) FROM {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE m.group_id = g.id{$hidden_sql}{$filter_sql} AND {$user_id_sql} AND m.is_confirmed = 1 AND m.is_banned = 0 AND m.is_mod = 1 ORDER BY date_modified ASC" );
@@ -2366,8 +2424,10 @@
 	 */
 	public static function total_group_count( $user_id = 0 ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			$user_id = bp_displayed_user_id();
+
+		$bp = buddypress();
 
 		if ( $user_id != bp_loggedin_user_id() && !bp_current_user_can( 'bp_moderate' ) ) {
@@ -2394,5 +2454,5 @@
 	 */
 	public static function get_invites( $user_id, $limit = false, $page = false, $exclude = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$pag_sql = ( !empty( $limit ) && !empty( $page ) ) ? $wpdb->prepare( " LIMIT %d, %d", intval( ( $page - 1 ) * $limit), intval( $limit ) ) : '';
@@ -2404,4 +2464,6 @@
 			$exclude_sql = '';
 		}
+
+		$bp = buddypress();
 
 		$paged_groups = $wpdb->get_results( $wpdb->prepare( "SELECT g.*, gm1.meta_value as total_member_count, gm2.meta_value as last_activity FROM {$bp->groups->table_name_groupmeta} gm1, {$bp->groups->table_name_groupmeta} gm2, {$bp->groups->table_name_members} m, {$bp->groups->table_name} g WHERE g.id = m.group_id AND g.id = gm1.group_id AND g.id = gm2.group_id AND gm2.meta_key = 'last_activity' AND gm1.meta_key = 'total_member_count' AND m.is_confirmed = 0 AND m.inviter_id != 0 AND m.invite_sent = 1 AND m.user_id = %d {$exclude_sql} ORDER BY m.date_modified ASC {$pag_sql}", $user_id ) );
@@ -2444,9 +2506,10 @@
 	 */
 	public static function check_has_invite( $user_id, $group_id, $type = 'sent' ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
 
+		$bp  = buddypress();
 		$sql = "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 0 AND inviter_id != 0";
 
@@ -2465,8 +2528,10 @@
 	 */
 	public static function delete_invite( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 0 AND inviter_id != 0 AND invite_sent = 1", $user_id, $group_id ) );
@@ -2481,8 +2546,10 @@
 	 */
 	public static function delete_request( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
  		return $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 0 AND inviter_id = 0 AND invite_sent = 0", $user_id, $group_id ) );
@@ -2498,8 +2565,10 @@
 	 */
 	public static function check_is_admin( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_admin = 1 AND is_banned = 0", $user_id, $group_id ) );
@@ -2515,8 +2584,10 @@
 	 */
 	public static function check_is_mod( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_mod = 1 AND is_banned = 0", $user_id, $group_id ) );
@@ -2532,8 +2603,10 @@
 	 */
 	public static function check_is_member( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 1 AND is_banned = 0", $user_id, $group_id ) );
@@ -2549,8 +2622,10 @@
 	 */
 	public static function check_is_banned( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT is_banned FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d", $user_id, $group_id ) );
@@ -2568,8 +2643,10 @@
 	 */
 	public static function check_is_creator( $user_id, $group_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name} WHERE creator_id = %d AND id = %d", $user_id, $group_id ) );
@@ -2584,8 +2661,10 @@
 	 */
 	public static function check_for_membership_request( $user_id, $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "SELECT id FROM {$bp->groups->table_name_members} WHERE user_id = %d AND group_id = %d AND is_confirmed = 0 AND is_banned = 0 AND inviter_id = 0", $user_id, $group_id ) );
@@ -2600,5 +2679,7 @@
 	 */
 	public static function get_random_groups( $user_id = 0, $total_groups = 5 ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		// If the user is logged in and viewing their random groups, we can show hidden and private groups
@@ -2617,5 +2698,7 @@
 	 */
 	public static function get_group_member_ids( $group_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_col( $wpdb->prepare( "SELECT user_id FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 1 AND is_banned = 0", $group_id ) );
@@ -2629,9 +2712,10 @@
 	 */
 	public static function get_group_administrator_ids( $group_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		$group_admins = wp_cache_get( $group_id, 'bp_group_admins' );
 
 		if ( false === $group_admins ) {
+			$bp = buddypress();
 			$group_admins = $wpdb->get_results( $wpdb->prepare( "SELECT user_id, date_modified FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_admin = 1 AND is_banned = 0", $group_id ) );
 
@@ -2649,5 +2733,7 @@
 	 */
 	public static function get_group_moderator_ids( $group_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_results( $wpdb->prepare( "SELECT user_id, date_modified FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_mod = 1 AND is_banned = 0", $group_id ) );
@@ -2661,5 +2747,7 @@
 	 */
 	public static function get_all_membership_request_user_ids( $group_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->get_col( $wpdb->prepare( "SELECT user_id FROM {$bp->groups->table_name_members} WHERE group_id = %d AND is_confirmed = 0 AND inviter_id = 0", $group_id ) );
@@ -2672,5 +2760,5 @@
 	 */
 	public static function get_all_for_group( $group_id, $limit = false, $page = false, $exclude_admins_mods = true, $exclude_banned = true, $exclude = false ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		_deprecated_function( __METHOD__, '1.8', 'BP_Group_Member_Query' );
@@ -2693,4 +2781,6 @@
 			$exclude_sql = " AND m.user_id NOT IN ({$exclude})";
 		}
+
+		$bp = buddypress();
 
 		if ( bp_is_active( 'xprofile' ) ) {
@@ -2737,5 +2827,7 @@
 	 */
 	public static function delete_all( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_members} WHERE group_id = %d", $group_id ) );
@@ -2750,5 +2842,7 @@
 	 */
 	public static function delete_all_for_user( $user_id ) {
-		global $bp, $wpdb;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		// Get all the group ids for the current user's groups and update counts
Index: /trunk/src/bp-groups/bp-groups-filters.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-filters.php	(revision 9470)
+++ /trunk/src/bp-groups/bp-groups-filters.php	(revision 9471)
@@ -142,5 +142,5 @@
  */
 function groups_add_forum_tables_sql( $sql = '' ) {
-	global $bp;
+	$bp = buddypress();
 
 	$sql .= 'JOIN ' . $bp->groups->table_name . ' AS g LEFT JOIN ' . $bp->groups->table_name_groupmeta . ' AS gm ON g.id = gm.group_id ';
@@ -156,5 +156,4 @@
  */
 function groups_add_forum_where_sql( $sql = '' ) {
-	global $bp;
 
 	// Define locale variable
@@ -190,4 +189,6 @@
 	// Assemble Voltron
 	$parts_string = implode( ' AND ', $parts );
+
+	$bp = buddypress();
 
 	// Set it to the global filter
@@ -207,11 +208,15 @@
  */
 function groups_filter_bbpress_caps( $value, $cap, $args ) {
-	global $bp;
 
 	if ( bp_current_user_can( 'bp_moderate' ) )
 		return true;
 
-	if ( 'add_tag_to' == $cap )
-		if ( $bp->groups->current_group->user_has_access ) return true;
+	if ( 'add_tag_to' === $cap ) {
+		$bp = buddypress();
+
+		if ( $bp->groups->current_group->user_has_access ) {
+			return true;
+		}
+	}
 
 	if ( 'manage_forums' == $cap && is_user_logged_in() )
Index: /trunk/src/bp-groups/bp-groups-functions.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-functions.php	(revision 9470)
+++ /trunk/src/bp-groups/bp-groups-functions.php	(revision 9471)
@@ -21,9 +21,8 @@
  * @since BuddyPress (1.5.0)
  *
- * @global BuddyPress $bp The one true BuddyPress instance
  * @return bool True if set, False if empty
  */
 function bp_groups_has_directory() {
-	global $bp;
+	$bp = buddypress();
 
 	return (bool) !empty( $bp->pages->groups->id );
@@ -301,5 +300,5 @@
  */
 function groups_is_valid_status( $status ) {
-	global $bp;
+	$bp = buddypress();
 
 	return in_array( $status, (array) $bp->groups->valid_status );
@@ -313,5 +312,5 @@
  */
 function groups_check_slug( $slug ) {
-	global $bp;
+	$bp = buddypress();
 
 	if ( 'wp' == substr( $slug, 0, 2 ) )
@@ -365,5 +364,4 @@
  */
 function groups_leave_group( $group_id, $user_id = 0 ) {
-	global $bp;
 
 	if ( empty( $user_id ) )
@@ -399,5 +397,4 @@
  */
 function groups_join_group( $group_id, $user_id = 0 ) {
-	global $bp;
 
 	if ( empty( $user_id ) )
@@ -427,4 +424,6 @@
 	if ( !$new_member->save() )
 		return false;
+
+	$bp = buddypress();
 
 	if ( !isset( $bp->groups->current_group ) || !$bp->groups->current_group || $group_id != $bp->groups->current_group->id )
@@ -705,7 +704,9 @@
  */
 function groups_get_current_group() {
-	global $bp;
-
-	$current_group = isset( $bp->groups->current_group ) ? $bp->groups->current_group : false;
+	$bp = buddypress();
+
+	$current_group = isset( $bp->groups->current_group )
+		? $bp->groups->current_group
+		: false;
 
 	return apply_filters( 'groups_get_current_group', $current_group );
@@ -722,8 +723,8 @@
  */
 function groups_avatar_upload_dir( $group_id = 0 ) {
-	global $bp;
-
-	if ( !$group_id )
-		$group_id = $bp->groups->current_group->id;
+
+	if ( empty( $group_id ) ) {
+		$group_id = bp_get_current_group_id();
+	}
 
 	$path    = bp_core_avatar_upload_path() . '/group-avatars/' . $group_id;
@@ -810,5 +811,5 @@
  */
 function groups_post_update( $args = '' ) {
-	global $bp;
+	$bp = buddypress();
 
 	$defaults = array(
Index: /trunk/src/bp-groups/bp-groups-screens.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-screens.php	(revision 9470)
+++ /trunk/src/bp-groups/bp-groups-screens.php	(revision 9471)
@@ -510,5 +510,4 @@
  */
 function groups_screen_group_request_membership() {
-	global $bp;
 
 	if ( !is_user_logged_in() )
@@ -912,5 +911,4 @@
  */
 function groups_screen_group_admin_delete_group() {
-	global $bp;
 
 	if ( 'delete-group' != bp_get_group_current_admin_tab() )
@@ -919,4 +917,6 @@
 	if ( ! bp_is_item_admin() && !bp_current_user_can( 'bp_moderate' ) )
 		return false;
+
+	$bp = buddypress();
 
 	if ( isset( $_REQUEST['delete-group-button'] ) && isset( $_REQUEST['delete-group-understand'] ) ) {
Index: /trunk/src/bp-groups/bp-groups-template.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-template.php	(revision 9470)
+++ /trunk/src/bp-groups/bp-groups-template.php	(revision 9471)
@@ -1500,5 +1500,4 @@
  */
 function bp_group_search_form() {
-	global $bp;
 
 	$action = bp_displayed_user_domain() . bp_get_groups_slug() . '/my-groups/search/';
@@ -1597,7 +1596,5 @@
  */
 function bp_groups_auto_join() {
-	global $bp;
-
-	return apply_filters( 'bp_groups_auto_join', (bool)$bp->groups->auto_join );
+	return apply_filters( 'bp_groups_auto_join', (bool) buddypress()->groups->auto_join );
 }
 
@@ -1861,7 +1858,9 @@
  */
 function bp_group_get_invite_status( $group_id = false ) {
-	global $bp, $groups_template;
+	global $groups_template;
 
 	if ( !$group_id ) {
+		$bp = buddypress();
+
 		if ( isset( $bp->groups->current_group->id ) ) {
 			// Default to the current group first
@@ -2558,8 +2557,10 @@
 	 */
 	function bp_get_group_accept_invite_link( $group = false ) {
-		global $groups_template, $bp;
+		global $groups_template;
 
 		if ( empty( $group ) )
 			$group =& $groups_template->group;
+
+		$bp = buddypress();
 
 		return apply_filters( 'bp_get_group_accept_invite_link', wp_nonce_url( trailingslashit( bp_loggedin_user_domain() . bp_get_groups_slug() . '/invites/accept/' . $group->id ), 'groups_accept_invite' ) );
@@ -2580,8 +2581,10 @@
 	 */
 	function bp_get_group_reject_invite_link( $group = false ) {
-		global $groups_template, $bp;
+		global $groups_template;
 
 		if ( empty( $group ) )
 			$group =& $groups_template->group;
+
+		$bp = buddypress();
 
 		return apply_filters( 'bp_get_group_reject_invite_link', wp_nonce_url( trailingslashit( bp_loggedin_user_domain() . bp_get_groups_slug() . '/invites/reject/' . $group->id ), 'groups_reject_invite' ) );
@@ -3623,5 +3626,5 @@
 
 function bp_group_creation_tabs() {
-	global $bp;
+	$bp = buddypress();
 
 	if ( !is_array( $bp->groups->group_creation_steps ) )
@@ -3648,5 +3651,5 @@
 
 function bp_group_creation_stage_title() {
-	global $bp;
+	$bp = buddypress();
 
 	echo apply_filters( 'bp_group_creation_stage_title', '<span>&mdash; ' . $bp->groups->group_creation_steps[bp_get_groups_current_create_step()]['name'] . '</span>' );
@@ -3657,5 +3660,5 @@
 }
 	function bp_get_group_creation_form_action() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( !bp_action_variable( 1 ) ) {
@@ -3668,9 +3671,10 @@
 
 function bp_is_group_creation_step( $step_slug ) {
-	global $bp;
 
 	/* Make sure we are in the groups component */
 	if ( !bp_is_groups_component() || !bp_is_current_action( 'create' ) )
 		return false;
+
+	$bp = buddypress();
 
 	/* If this the first step, we can just accept and return true */
@@ -3693,5 +3697,5 @@
 
 function bp_is_group_creation_step_complete( $step_slugs ) {
-	global $bp;
+	$bp = buddypress();
 
 	if ( !isset( $bp->groups->completed_create_steps ) )
@@ -3715,5 +3719,5 @@
 
 function bp_are_previous_group_creation_steps_complete( $step_slug ) {
-	global $bp;
+	$bp = buddypress();
 
 	/* If this is the first group creation step, return true */
@@ -3740,5 +3744,5 @@
 }
 	function bp_get_new_group_id() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( isset( $bp->groups->new_group_id ) )
@@ -3754,5 +3758,5 @@
 }
 	function bp_get_new_group_name() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( isset( $bp->groups->current_group->name ) )
@@ -3768,5 +3772,5 @@
 }
 	function bp_get_new_group_description() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( isset( $bp->groups->current_group->description ) )
@@ -3782,5 +3786,6 @@
 }
 	function bp_get_new_group_enable_forum() {
-		global $bp;
+		$bp = buddypress();
+
 		return (int) apply_filters( 'bp_get_new_group_enable_forum', $bp->groups->current_group->enable_forum );
 	}
@@ -3790,5 +3795,6 @@
 }
 	function bp_get_new_group_status() {
-		global $bp;
+		$bp = buddypress();
+
 		return apply_filters( 'bp_get_new_group_status', $bp->groups->current_group->status );
 	}
@@ -3798,5 +3804,5 @@
 }
 	function bp_get_new_group_avatar( $args = '' ) {
-		global $bp;
+		$bp = buddypress();
 
 		$defaults = array(
@@ -3820,5 +3826,5 @@
 }
 	function bp_get_group_creation_previous_link() {
-		global $bp;
+		$bp = buddypress();
 
 		foreach ( (array) $bp->groups->group_creation_steps as $slug => $name ) {
@@ -3849,5 +3855,5 @@
 	 */
 	function bp_get_groups_current_create_step() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( !empty( $bp->groups->current_create_step ) ) {
@@ -3861,5 +3867,5 @@
 
 function bp_is_last_group_creation_step() {
-	global $bp;
+	$bp = buddypress();
 
 	$keys      = array_keys( $bp->groups->group_creation_steps );
@@ -3873,5 +3879,5 @@
 
 function bp_is_first_group_creation_step() {
-	global $bp;
+	$bp = buddypress();
 
 	$keys       = array_keys( $bp->groups->group_creation_steps );
@@ -3888,5 +3894,5 @@
 }
 	function bp_get_new_group_invite_friend_list( $args = '' ) {
-		global $bp;
+		$bp = buddypress();
 
 		if ( !bp_is_active( 'friends' ) )
@@ -3945,5 +3951,5 @@
  */
 function bp_groups_header_tabs() {
-	global $bp;?>
+	$bp = buddypress(); ?>
 
 	<li<?php if ( !bp_action_variable( 0 ) || bp_is_action_variable( 'recently-active', 0 ) ) : ?> class="current"<?php endif; ?>><a href="<?php echo trailingslashit( bp_displayed_user_domain() . bp_get_groups_slug() . '/my-groups/recently-active' ) ?>"><?php _e( 'Recently Active', 'buddypress' ) ?></a></li>
@@ -4095,5 +4101,5 @@
 }
 	function bp_get_group_avatar_delete_link() {
-		global $bp;
+		$bp = buddypress();
 
 		return apply_filters( 'bp_get_group_avatar_delete_link', wp_nonce_url( bp_get_group_permalink( $bp->groups->current_group ) . 'admin/group-avatar/delete', 'bp_group_avatar_delete' ) );
Index: /trunk/src/bp-members/bp-members-adminbar.php
===================================================================
--- /trunk/src/bp-members/bp-members-adminbar.php	(revision 9470)
+++ /trunk/src/bp-members/bp-members-adminbar.php	(revision 9471)
@@ -21,5 +21,5 @@
  */
 function bp_members_admin_bar_my_account_menu() {
-	global $bp, $wp_admin_bar;
+	global $wp_admin_bar;
 
 	// Bail if this is an ajax request
@@ -29,4 +29,6 @@
 	// Logged in user
 	if ( is_user_logged_in() ) {
+
+		$bp = buddypress();
 
 		// Stored in the global so we can add menus easily later on
@@ -73,5 +75,5 @@
  */
 function bp_members_admin_bar_user_admin_menu() {
-	global $bp, $wp_admin_bar;
+	global $wp_admin_bar;
 
 	// Only show if viewing a user
@@ -82,4 +84,6 @@
 	if ( !current_user_can( 'edit_users' ) || bp_is_my_profile() )
 		return false;
+
+	$bp = buddypress();
 
 	// Unique ID for the 'My Account' menu
Index: /trunk/src/bp-members/bp-members-functions.php
===================================================================
--- /trunk/src/bp-members/bp-members-functions.php	(revision 9470)
+++ /trunk/src/bp-members/bp-members-functions.php	(revision 9471)
@@ -21,5 +21,5 @@
  */
 function bp_members_has_directory() {
-	global $bp;
+	$bp = buddypress();
 
 	return (bool) !empty( $bp->pages->members->id );
Index: /trunk/src/bp-members/bp-members-screens.php
===================================================================
--- /trunk/src/bp-members/bp-members-screens.php	(revision 9470)
+++ /trunk/src/bp-members/bp-members-screens.php	(revision 9471)
@@ -65,5 +65,5 @@
  */
 function bp_core_screen_signup() {
-	global $bp;
+	$bp = buddypress();
 
 	if ( ! bp_is_current_component( 'register' ) || bp_current_action() )
